package zh2;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;

public class SMSClient implements ActionListener {
	// =========================================================================
	// members
	protected final JFrame frame = new JFrame();
	protected final JTextArea textArea = new JTextArea();

	protected JMenuItem sendMenuItem = new JMenuItem("SMS elkuldese");
	protected JMenuItem getDataMenuItem = new JMenuItem("Adatok lekerdezese");
	
	protected ISMSList smsList;

	// =========================================================================
	// constructors
	/**
	 * Konstruktor, elkesziti a menut, es egy scrollbar ({@link JScrollPane})
	 * segitsegevel berakja a szerkeszto feluletet, valamint allit meretet.
	 * 
	 * @see JScrollPane
	 */
	public SMSClient() {
		frame.setJMenuBar(createMenu());
		frame.getContentPane().add(new JScrollPane(textArea));
		frame.setPreferredSize(new Dimension(200, 300));
		handleNew();
	}

	// =========================================================================
	// private & protected methods
	/**
	 * Elkesziti a menut.
	 * 
	 * Reszletek a {@link #newAction} mezonel.
	 * 
	 * @return Az elkeszitett menu.
	 */
	private JMenuBar createMenu() {
		JMenuBar menuBar = new JMenuBar();
		JMenu file = new JMenu("Fajl");
		file.setMnemonic('f');

		sendMenuItem.setActionCommand("send");
		sendMenuItem.setMnemonic(KeyEvent.VK_E);
		sendMenuItem.setAccelerator(KeyStroke.getKeyStroke("ctrl E"));
		sendMenuItem.addActionListener(this);

		file.add(sendMenuItem);

		// itt lehet tovabbi menuelemeket felpakolni a newMenuItem mintajara

		menuBar.add(file);
		return menuBar;
	}

	
	protected void handleNew() {
		textArea.setText("");
	}

	protected String sendDataOnSocket(String server, int port, String phoneNumber,
			String text ){
			return null;
	}

	protected JFrame getFrame() {
		return frame;
	}

	/**
	 * A szoksos createAndShowGUI()...
	 */
	protected static void createAndShowGUI() {
		SMSClient client = new SMSClient();
		JFrame frame = client.getFrame();
		frame.pack();
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		frame.setVisible(true);
	}

	// =========================================================================
	// Public functions
	/**
	 * A szokasos main fuggveny.
	 * 
	 * @param args
	 *            Parancssor...
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				createAndShowGUI();
			}
		});
	}
	
	// =========================================================================
	// Dummy functions
	private void getDummyData(){
		smsList.addSMS( "06201234567", "Este mozi!" );
		smsList.addSMS( "06307654321", "Hajra a ZH-n!" );
		smsList.addSMS( "06201234567", "Menjunk inkabb bowlingozni..." );
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		
	}
}
